package com.fins.html.utils;

import com.fins.common.support.JSONXML;
import com.fins.html.utils.VerifyUtils;
import com.fins.html.view.data.DataOption;
import com.fins.modules.utils.JsonUtils;
import com.finstone.framework.support.IUser;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;
import javax.servlet.http.HttpServletRequest;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.subject.Subject;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

public class XMLUtils {

   static Logger logger = LogManager.getLogger(XMLUtils.class.getName());


   private static boolean json2Xml(StringBuffer xmlsb, String name, String strJson) {
      try {
         try {
            JSONObject e = new JSONObject(strJson);
            xmlsb.append("<").append(name).append(">");
            xmlsb.append(JSONXML.toString(e));
            xmlsb.append("</").append(name).append(">");
         } catch (JSONException var5) {
            JSONArray jsonArray = new JSONArray(strJson);
            xmlsb.append("<").append(name).append(">");
            xmlsb.append(JSONXML.toString(jsonArray));
            xmlsb.append("</").append(name).append(">");
         }

         return true;
      } catch (Exception var6) {
         xmlsb.append("<").append(name).append(">");
         xmlsb.append(strJson);
         xmlsb.append("</").append(name).append(">");
         return true;
      }
   }

   public static String getRequestXml(String trancode, Map map, IUser user) {
      StringBuffer xmlRequest = new StringBuffer();
      xmlRequest.append("<ttroot>");
      xmlRequest.append("<transcode>").append(trancode).append("</transcode>");
      xmlRequest.append("<ttsession>");
      if(user != null) {
         doXMLParam(xmlRequest, "gsuserid", user.getId());
         doXMLParam(xmlRequest, "gsloginname", user.getLoginName());
         doXMLParam(xmlRequest, "gsusername", user.getUserName());
         Map keys = user.getProperties();
         Set xml = keys.keySet();
         Iterator pageSize = xml.iterator();

         while(pageSize.hasNext()) {
            String sindex = (String)pageSize.next();
            doXMLParam(xmlRequest, "gs" + sindex, keys.get(sindex));
         }
      }

      xmlRequest.append("</ttsession>");
      xmlRequest.append("<inxml>");
      Set keys1 = map.keySet();
      Iterator xml1 = keys1.iterator();

      while(xml1.hasNext()) {
         String pageSize1 = (String)xml1.next();
         if(!pageSize1.equals("parameter")) {
            Object sindex1 = map.get(pageSize1);
            if(sindex1 != null) {
               if(!(sindex1 instanceof String) && !(sindex1 instanceof Number)) {
                  json2Xml(xmlRequest, pageSize1, JsonUtils.toJson(sindex1));
               } else {
                  xmlRequest.append("<").append(pageSize1).append(">");
                  xmlRequest.append(sindex1);
                  xmlRequest.append("</").append(pageSize1).append(">");
               }
            } else {
               json2Xml(xmlRequest, pageSize1, "");
            }
         }
      }

      if(map.containsKey("pageIndex") && map.containsKey("pageSize")) {
         int xml2 = Integer.valueOf(map.get("pageIndex").toString()).intValue();
         int pageSize2 = Integer.valueOf(map.get("pageSize").toString()).intValue();
         int sindex2 = xml2 * pageSize2 + 1;
         int eindex = (xml2 + 1) * pageSize2;
         xmlRequest.append("<pagecond>");
         xmlRequest.append("<startrow>").append(sindex2).append("</startrow>");
         xmlRequest.append("<endrow>").append(eindex).append("</endrow>");
         xmlRequest.append("</pagecond>");
      }

      xmlRequest.append("</inxml>");
      xmlRequest.append("</ttroot>");
      String xml3 = xmlRequest.toString();
      if(xml3.length() < 2000) {
         logger.info(xml3);
      } else {
         logger.info(xml3.substring(0, 2000));
      }

      return xml3;
   }

   public static String getRequestXml(HttpServletRequest request, DataOption actionoption) {
      StringBuffer xmlRequest = new StringBuffer();
      xmlRequest.append("<ttroot>");
      xmlRequest.append("<transcode>").append(actionoption.getTrancode()).append("</transcode>");
      xmlRequest.append("<ttsession>");
      Subject subject = SecurityUtils.getSubject();
      Map parameterMap;
      if(subject != null && subject.getPrincipal() != null) {
         IUser enu = (IUser)subject.getPrincipal();
         doXMLParam(xmlRequest, "gsuserid", enu.getId());
         doXMLParam(xmlRequest, "gsloginname", enu.getLoginName());
         doXMLParam(xmlRequest, "gsusername", enu.getUserName());
         parameterMap = enu.getProperties();
         Set xml = parameterMap.keySet();
         Iterator index = xml.iterator();

         while(index.hasNext()) {
            String pageSize = (String)index.next();
            doXMLParam(xmlRequest, "gs" + pageSize, parameterMap.get(pageSize));
         }
      }

      xmlRequest.append("</ttsession>");
      xmlRequest.append("<inxml>");
      Enumeration enu1 = request.getParameterNames();
      parameterMap = request.getParameterMap();

      String xml1;
      while(enu1.hasMoreElements()) {
         xml1 = (String)enu1.nextElement();
         if(request.getParameter(xml1) != null) {
            json2Xml(xmlRequest, xml1, VerifyUtils.scriptVerify(request.getParameter(xml1)));
         }
      }

      if(parameterMap.containsKey("parameter")) {
         Map xml2 = jsonToMap(VerifyUtils.scriptVerify(request.getParameter("parameter")));
         if(xml2.containsKey("pageIndex") && xml2.containsKey("pageSize")) {
            int index1 = Integer.valueOf(xml2.get("pageIndex").toString()).intValue();
            int pageSize1 = Integer.valueOf(xml2.get("pageSize").toString()).intValue();
            int sindex = index1 * pageSize1 + 1;
            int eindex = (index1 + 1) * pageSize1;
            xmlRequest.append("<pagecond>");
            xmlRequest.append("<startrow>").append(sindex).append("</startrow>");
            xmlRequest.append("<endrow>").append(eindex).append("</endrow>");
            xmlRequest.append("</pagecond>");
         }
      }

      xmlRequest.append("</inxml>");
      xmlRequest.append("</ttroot>");
      xml1 = xmlRequest.toString();
      if(xml1.length() < 2000) {
         logger.info(xml1);
      } else {
         logger.info(xml1.substring(0, 2000));
      }

      return xml1;
   }

   private static void doXMLParam(StringBuffer xmlsb, String name, Object o) {
      xmlsb.append("<").append(name).append(">");
      if(o != null) {
         xmlsb.append(o.toString());
      }

      xmlsb.append("</").append(name).append(">");
   }

   public static void main(String[] a) {
      HashMap p = new HashMap();
      HashMap p1 = new HashMap();
      p1.put("id", "00001");
      p1.put("number", Integer.valueOf(2));
      p.put("a", p1);
      p.put("ee", Character.valueOf('d'));
      p.put("ee2", Integer.valueOf(1));
      p.put("ee33", Float.valueOf(1.1F));
      p.put("e3", Double.valueOf(1.1D));
      p.put("eeeww3", Long.valueOf(1000000000000L));
      ArrayList ae = new ArrayList();
      ae.add(p1);
      p.put("array", ae);
      System.out.println(getRequestXml("dd", p, (IUser)null));
   }

   public static Map jsonToMap(String json) {
      return JsonUtils.fromJson(json);
   }

}
